﻿class GraphClip extends MovieClip{
	
	//set in init()
	var owner:MovieClip
	var rect:flash.geom.Rectangle;
	var data:Array;

	//created here
	var graph:MovieClip;
	var _txt;
	

	function GraphClip(){
	}
	
	
	function selectDot(id:String){
		//highlight dot
		var total = data.length;
		for(var i = 0; i<total; i++){
			var thisDot:MovieClip = graph["p"+i];
			thisDot.selected = (thisDot.id == id);
			thisDot.gotoAndStop(1+(2*thisDot.selected));
		}
		
		owner.selectUserInList(id);
	}
	function rollDot(id:String,value:Number, x:Number, y:Number){
		owner.showTextOnDot(id, value, x, y);
	}
	
	
	
	function init( p_owner:MovieClip, 
					p_rect:flash.geom.Rectangle, 
					p_data:Array){
		//set our vars
		owner=p_owner;
		rect=p_rect;
		data=p_data;
		
		graph=this.createEmptyMovieClip("graph",0);

		var top=10;
		var bottom=rect.height-10
	
		//put the dots on:
		var total = data.length;
		for(var i = 0; i<total; i++){
			var thisUser = data[i];
			var thisPoint = graph.attachMovie("point_on_graph","p"+i,i,
					  						{_x:10+(i*25), 
					  						 _y: (bottom - Number(thisUser.percentage)*((bottom-top)/100)), 
											 controller:this,
											 selected:false,
											 id:thisUser.id,
											 percentage:thisUser.percentage});
			//behavior for button inside point
			thisPoint.stop();
			var _btn:MovieClip = thisPoint["_btn"];
			_btn.owner = thisPoint;
			_btn.onRollOver = function(){
				this.owner.gotoAndStop(2);
				this.owner.controller.rollDot(this.owner.id, 
											   this.owner.percentage,
											 this.owner._x, this.owner._y);
			}
			_btn.onRollOut = _btn.onDragOut = function(){
				this.owner.gotoAndStop(1+(2*this.owner.selected));
				this.owner.controller.rollDot(undefined);
			}
			_btn.onPress = function(){
				this.owner.controller.selectDot(this.owner.id);
			}
		}
		
		//grid lines
		lineStyle(1,0,50);
		//100 down to 0
		var width = this._width+50;
		var spaceForTen = (bottom-top)/10;
		for(var i = 0; i<11; i++){
			moveTo(0, top+(i*spaceForTen));
			lineTo(width, top+(i*spaceForTen));
		}
		
		//average
		lineStyle(2,0x0000FF,90);
		var ave = bottom - getMeanScore(data) * ((bottom-top)/100)
		moveTo(0,ave);
		lineTo(this._width, ave);
		
	}
	function getMeanScore(){
		var total = data.length;
		var sum = 0;
		for(var i = 0; i<total; i++){
			sum+=data[i].percentage;
		}
		return sum/total;
	}
}