﻿/*=========
usage:
var gateway:XMLGateway=new XMLGateway("POST");
function onResult(evt){
}
gateway.addEventListener("onResult", this);

gateway.trigger(sendAndLoad:Boolean, 
				tracker:Object,
				methodName:String,
				LoadVars_or_XML:Object);

*/ //=========

//EventDispatcher needs this
import mx.events.EventDispatcher;


class XMLGateway{
	
	//EventDispatcher needs these
	var addEventListener:Function;
	var removeEventListener:Function;
	var dispatchEvent:Function;
	var dispatchQueue:Function;
	
	
	//for this class:
	private var form:String;
	
	//========
	//CONTRUCTOR
	//========
	function XMLGateway(p_form:String){
		//EventDispatcher needs this
		EventDispatcher.initialize(this);
		form=p_form;
	}
	
	//========
	// TRIGGER
	//========
	function trigger(useNetwork:Boolean, p_id:Object,
					p_method:String,out_obj:Object){
		
		
		//------------CALLBACK
		var in_xml:XML=new XML();
		
		in_xml.ignoreWhite=true;
		in_xml["owner"]=this;//can't set .owner because not dynamic class
		in_xml["id"]=p_id;
		in_xml["methodName"]=p_method;
		
		in_xml.onLoad=function(success:Boolean){
			
			if(success==false){
				this.owner.dispatchEvent({type:"onFault", 
				   	 	  				target:this.owner,
				   	  	       			value:"success false",
				   	  	       			methodName:this.methodName,
				   	  	      			tracker:this.id
				   	  	      			});
				return;
			}
			//success true:
			this.owner.dispatchEvent({type:"onResult", 
				   	 	  				target:this.owner,
				   	  	       			value:this,
				   	  	       			methodName:this.methodName,
				   	  	       			tracker:this.id
				   	  	       			});
			
		}
		
		if(useNetwork==false){
			in_xml.load(p_method, form);
		}else{
			out_obj.sendAndLoad(p_method, in_xml, form);
		}
		
	}	
}