﻿import mx.xpath.*;


class QuizHolder extends mx.core.UIObject implements IQuizHolder{
	
	//set in attachMovie
	var owner:MovieClip;//"controller"

	//for class
	var quiz:Quiz;//really Quiz.as ("model")
	var currentQuestion:MovieClip;//holds the question.swf
	var currentQuestionNumber:Number;
	var defaultStage={width:550, height:400};
	
	//onstage
	var nextB:mx.controls.Button;
	var prevB:mx.controls.Button;

	//created here:
	var confirmationDialog:Object;

	function QuizHolder(){
		init();
	}

	function click(evt){
		
		switch(evt.target){
			case nextB:
				nextQuestion();
				break;
			case prevB:
				prevQuestion();
				break;
		}
	}
	
	//question will call this:
	public function canProceed(way:Boolean){
		nextB.enabled=way;
	}
	
	function canGoBack(way:Boolean){
		prevB.enabled=way;
	}
	
	
	function initButtons(){
		nextB.addEventListener("click", this)
		prevB.addEventListener("click", this);
		nextB.move(defaultStage.width-nextB.width,defaultStage.height-nextB.height);
		prevB.move(0,defaultStage.height-prevB.height);
	}
	function init(){		
		this.createClassObject(mx.controls.Button,"nextB",1,{label:"Next", 	 enabled:false});
		this.createClassObject(mx.controls.Button,"prevB",2,{label:"Previous", enabled:false});
		initButtons();
	}
	
	function showSummary(){
		canProceed(false);
		canGoBack(false);
		
		
		//can load a .swf with review information?
		currentQuestion.removeMovieClip();
		canProceed(false);
		
		var myClickHandler = new Object();
		myClickHandler.target=this;
		myClickHandler.click=function(evt){
			if(evt.detail==mx.controls.Alert.YES){
				this.target.owner.submitResults();
			}else{
				this.target.gotoLastQuestion();
			}
		};

		confirmationDialog = mx.controls.Alert.show("You finished the quiz!\rAre you ready to submit your results (if not, click the No button and you can review your answers)", 
														"Submit Results", 
															mx.controls.Alert.YES|mx.controls.Alert.NO, null, myClickHandler);
	}
	
	function displayQuestion(n:Number){
		
		currentQuestionNumber=n;
		
		canGoBack(n>0);
		var thisQuestionData:XMLNode=quiz.getQuestion(n);
		
		var type=thisQuestionData.attributes.type+".swf";
		
		var dataToPass={owner:this,questionData:thisQuestionData};
		
		currentQuestion=this.createEmptyMovieClip("currentQuestion",0);
		
		//make mcl
		var mcl:MovieClipLoader=new MovieClipLoader();
		//and listener
		var listener=new Object();
		//when full loaded, set vars and initialize
		listener.onLoadInit=function(target:MovieClip){
			target.init(dataToPass.owner, 
						dataToPass.questionData);
		}
		mcl.addListener(listener);
		mcl.loadClip(type, currentQuestion);
		
	}
	
	//===============
	/// required by the interface
	function getNodeValue(data:XMLNode, path:String):String{
		return XPathAPI.selectSingleNode(data, path).firstChild.nodeValue;
	}
	function getNode(data:XMLNode, path:String):XMLNode{
		return XPathAPI.selectSingleNode(data, path);
	}
	function getNodes(data:XMLNode, path:String):Array{
		return XPathAPI.selectNodeList(data, path);
	}
	//======================
	
	function nextQuestion(){
		quiz.setAnswer(currentQuestionNumber, currentQuestion.getAnswers());
		//pass it up
		owner.nextQuestion();
	}
	
	function prevQuestion(){			
		quiz.setAnswer(currentQuestionNumber, currentQuestion.getAnswers());
		//pass it up
		owner.prevQuestion();
	}
	
	function gotoLastQuestion(){
		//pass it up
		owner.gotoLastQuestion();
	}
	
	//called from Quiz.as 
	public function refToQuiz(p_quiz:Quiz){
		quiz=p_quiz;
	}
}